/// <reference types="node" />
import * as Config from './types';
export declare enum CmdShow {
    SW_HIDE = 0,
    SW_SHOWNORMAL = 1,
    SW_SHOWMINIMIZED = 2,
    SW_SHOWMAXIMIZED = 3,
    SW_MAXIMIZE = 3,
    SW_SHOWNOACTIVATE = 4,
    SW_SHOW = 5,
    SW_MINIMIZE = 6,
    SW_SHOWMINNOACTIVE = 7,
    SW_SHOWNA = 8,
    SW_RESTORE = 9,
    SW_SHOWDEFAULT = 10,
    SW_FORCEMINIMIZE = 11,
}
export interface User32 {
    EnumWindows: EnumWindows;
    GetWindowThreadProcessId(hWnd: number, lpdwProcessId: Buffer): number;
    GetWindowTextW(hWnd: number, lpString: Buffer, nMaxCount: number): number;
    IsWindowVisible(hWnd: number): boolean;
    ShowWindow(hWnd: number, nCmdShow: number): boolean;
    GetParent(hWnd: number): number | null;
    GetAncestor(hwnd: number, gaFlags: number): number;
}
export interface EnumWindows {
    (lpEnumFunc: Buffer, lParam: Config.Tno): boolean;
    async(lpEnumFunc: Buffer, lParam: Config.Tno, cb: (err: Error) => void): boolean;
}
export declare const api: User32;
export interface TaskConfig {
    tno: Config.Tno;
    task: Map<Config.Tno, Config.Task>;
}
export declare const taskConfig: TaskConfig;
export declare type ErrCode = number;
export interface ExecRet {
    err: ErrCode;
    msg: string;
    pids: Config.Pid[];
    hwnds: Config.Hwnd[];
}
export declare const enumWindowsProc: Buffer;
export declare function validate_cmdshow(nCmdShow: CmdShow): boolean;
export declare function show(hWnd: number, nCmdShow: CmdShow, onlyMainWin: boolean): Promise<void | Config.Hwnd>;
export declare function get_hwnds(p: Config.matchParam, task?: Config.Task): Promise<number[] | void>;
export declare function get_hwnd(p: Config.matchParam, task: Config.Task): Promise<number[] | void>;
export declare function filter_main_hwnd(arr: number[]): number | void;
export declare function is_main_window(hWnd: number): boolean;
export declare function create_task(): Config.Task;
